#ifndef MS_PACKET_SAVE_REQUEST
#define MS_PACKET_SAVE_REQUEST
#include <stdio.h>
#include <sys/un.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>

#include <msgba/client_connection_data.h>

struct msPacket;
struct msPacketSaveRequestData;

/**
 * The packet kind received when the client wants a savestate.
 */
struct msPacketSaveRequest {
    //! The unique for the client identifier for handling its response.
    uint64_t identifier;
};

/**
 * Destroys the msPacketSaveRequest 
 * @param selfPtr The pointer to the pointer to msPacketSaveRequest to null it after this operation.
 */
void
msPacketSaveRequestDestroy(struct msPacketSaveRequest **selfPtr);

/**
 * Handles the msPacketSaveRequest
 * @param packet The packet containing msPacketSaveRequest, should have PACKET_GET_SAVE_REQUEST as its id.
 * @param self This object.
 * @param data The session data.
 */
bool
msPacketSaveRequestHandle(const struct msPacket *packet, struct msPacketSaveRequest *self,
        struct msClientConnectionData *const data);

/**
 * Retrieves the msPacketSaveRequest contained in the packet rawData.
 * @param packet The packet containing msPacketSaveRequest, should have PACKET_GET_SAVE_REQUEST as its id.
 * @param clientFd The source of this packet.
 * @param data The session data.
 */
bool
msPacketSaveRequestGet(const struct msPacket *packet, int clientFd,
        struct msClientConnectionData *const data);
/**
 * Destroys the struct msPacketSaveRequestData.
 * @param selfPtr A pointer to a pointer to this object.
 */
void
msPacketSaveRequestDataDestroy(struct msPacketSaveRequestData **selfPtr);
#endif
