#ifndef MS_PACKET_SAVE_RESPONSE
#define MS_PACKET_SAVE_RESPONSE

#include <stdint.h>
#include <stddef.h>

struct msPacket;

/**
 * Structure representing a save response response.
 */
struct msPacketSaveResponse {
    //! The identifier of the request packet so the client nows that this is the response to that packet.
    uint64_t identifier;
    //! The length in bytes of the next field.
    size_t saveLen;
    //! The savestate content.
    unsigned char *save;
};

/**
 * Ends the life in memory of the send_frame packet.
 * @param selfPtr A pointer to a pointer to this object.
 */
void
msPacketSaveResponseDestroy(struct msPacketSaveResponse **selfPtr);

/**
 * Creates a new save response packet.
 * @param identifier Who this packet responses.
 * @param saveLen The size of the save in bytes.
 * @param save The bytes representing the savestate.
 */
struct msPacketSaveResponse *
msPacketSaveResponseNew(uint64_t identifier, size_t saveLen, unsigned char *save);
/**
 * Converts this object to byte array.
 * @param self This object.
 * @param len (Output) A pointer to a number containing the resulting size in bytes.
 */
unsigned char *
msPacketSaveResponseSerialize(struct msPacketSaveResponse *const self, size_t *len);
#endif
